// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias DeleteWebhookCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to remove webhook integration if you decide to switch back to getUpdates. Returns True on success. Requires no parameters.
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletewebhook>
    @discardableResult
    public func deleteWebhookSync(_ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("deleteWebhook", defaultParameters["deleteWebhook"], parameters)
    }

    /// Use this method to remove webhook integration if you decide to switch back to getUpdates. Returns True on success. Requires no parameters.
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#deletewebhook>
    public func deleteWebhookAsync(_ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: DeleteWebhookCompletion? = nil) {
        return requestAsync("deleteWebhook", defaultParameters["deleteWebhook"], parameters,
            queue: queue, completion: completion)
    }
}

