// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias EditMessageTextCompletion = (_ result: MessageOrBool?, _ error: DataTaskError?) -> ()

    /// Use this method to edit text and game messages sent by the bot or via the bot (for inline bots). On success, if edited message is sent by the bot, the edited Message is returned, otherwise True is returned.
    /// - Parameters:
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    ///     - text: New text of the message
    ///     - parse_mode: Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in your bot's message.
    ///     - disable_web_page_preview: Disables link previews for links in this message
    ///     - reply_markup: A JSON-serialized object for an inline keyboard.
    /// - Returns: MessageOrBool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#editmessagetext>
    @discardableResult
    public func editMessageTextSync(
            chatId: ChatId? = nil,
            messageId: Int? = nil,
            inlineMessageId: String? = nil,
            text: String,
            parseMode: ParseMode? = nil,
            disableWebPagePreview: Bool? = nil,
            replyMarkup: InlineKeyboardMarkup? = nil,
            _ parameters: [String: Any?] = [:]) -> MessageOrBool? {
        return requestSync("editMessageText", defaultParameters["editMessageText"], parameters, [
            "chat_id": chatId,
            "message_id": messageId,
            "inline_message_id": inlineMessageId,
            "text": text,
            "parse_mode": parseMode?.rawValue,
            "disable_web_page_preview": disableWebPagePreview,
            "reply_markup": replyMarkup])
    }

    /// Use this method to edit text and game messages sent by the bot or via the bot (for inline bots). On success, if edited message is sent by the bot, the edited Message is returned, otherwise True is returned.
    /// - Parameters:
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    ///     - text: New text of the message
    ///     - parse_mode: Send Markdown or HTML, if you want Telegram apps to show bold, italic, fixed-width text or inline URLs in your bot's message.
    ///     - disable_web_page_preview: Disables link previews for links in this message
    ///     - reply_markup: A JSON-serialized object for an inline keyboard.
    /// - Returns: MessageOrBool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#editmessagetext>
    public func editMessageTextAsync(
            chatId: ChatId? = nil,
            messageId: Int? = nil,
            inlineMessageId: String? = nil,
            text: String,
            parseMode: ParseMode? = nil,
            disableWebPagePreview: Bool? = nil,
            replyMarkup: InlineKeyboardMarkup? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: EditMessageTextCompletion? = nil) {
        return requestAsync("editMessageText", defaultParameters["editMessageText"], parameters, [
            "chat_id": chatId,
            "message_id": messageId,
            "inline_message_id": inlineMessageId,
            "text": text,
            "parse_mode": parseMode?.rawValue,
            "disable_web_page_preview": disableWebPagePreview,
            "reply_markup": replyMarkup],
            queue: queue, completion: completion)
    }
}

