// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias GetFileCompletion = (_ result: File?, _ error: DataTaskError?) -> ()

    /// Use this method to get basic info about a file and prepare it for downloading. For the moment, bots can download files of up to 20MB in size. On success, a File object is returned. The file can then be downloaded via the link https://api.telegram.org/file/bot<token>/<file_path>, where <file_path> is taken from the response. It is guaranteed that the link will be valid for at least 1 hour. When the link expires, a new one can be requested by calling getFile again.
    /// - Parameters:
    ///     - file_id: File identifier to get info about
    /// - Returns: File on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getfile>
    @discardableResult
    public func getFileSync(
            fileId: String,
            _ parameters: [String: Any?] = [:]) -> File? {
        return requestSync("getFile", defaultParameters["getFile"], parameters, [
            "file_id": fileId])
    }

    /// Use this method to get basic info about a file and prepare it for downloading. For the moment, bots can download files of up to 20MB in size. On success, a File object is returned. The file can then be downloaded via the link https://api.telegram.org/file/bot<token>/<file_path>, where <file_path> is taken from the response. It is guaranteed that the link will be valid for at least 1 hour. When the link expires, a new one can be requested by calling getFile again.
    /// - Parameters:
    ///     - file_id: File identifier to get info about
    /// - Returns: File on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getfile>
    public func getFileAsync(
            fileId: String,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: GetFileCompletion? = nil) {
        return requestAsync("getFile", defaultParameters["getFile"], parameters, [
            "file_id": fileId],
            queue: queue, completion: completion)
    }
}

