// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias GetUpdatesCompletion = (_ result: [Update]?, _ error: DataTaskError?) -> ()

    /// Use this method to receive incoming updates using long polling (wiki). An Array of Update objects is returned.
    /// - Parameters:
    ///     - offset: Identifier of the first update to be returned. Must be greater by one than the highest among the identifiers of previously received updates. By default, updates starting with the earliest unconfirmed update are returned. An update is considered confirmed as soon as getUpdates is called with an offset higher than its update_id. The negative offset can be specified to retrieve updates starting from -offset update from the end of the updates queue. All previous updates will forgotten.
    ///     - limit: Limits the number of updates to be retrieved. Values between 1—100 are accepted. Defaults to 100.
    ///     - timeout: Timeout in seconds for long polling. Defaults to 0, i.e. usual short polling. Should be positive, short polling should be used for testing purposes only.
    ///     - allowed_updates: List the types of updates you want your bot to receive. For example, specify [“message”, “edited_channel_post”, “callback_query”] to only receive updates of these types. See Update for a complete list of available update types. Specify an empty list to receive all updates regardless of type (default). If not specified, the previous setting will be used.
    ///       Please note that this parameter doesn't affect updates created before the call to the getUpdates, so unwanted updates may be received for a short period of time.
    /// - Returns: [Update] on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getupdates>
    @discardableResult
    public func getUpdatesSync(
            offset: Int? = nil,
            limit: Int? = nil,
            timeout: Int? = nil,
            allowedUpdates: [String]? = nil,
            _ parameters: [String: Any?] = [:]) -> [Update]? {
        return requestSync("getUpdates", defaultParameters["getUpdates"], parameters, [
            "offset": offset,
            "limit": limit,
            "timeout": timeout,
            "allowed_updates": allowedUpdates])
    }

    /// Use this method to receive incoming updates using long polling (wiki). An Array of Update objects is returned.
    /// - Parameters:
    ///     - offset: Identifier of the first update to be returned. Must be greater by one than the highest among the identifiers of previously received updates. By default, updates starting with the earliest unconfirmed update are returned. An update is considered confirmed as soon as getUpdates is called with an offset higher than its update_id. The negative offset can be specified to retrieve updates starting from -offset update from the end of the updates queue. All previous updates will forgotten.
    ///     - limit: Limits the number of updates to be retrieved. Values between 1—100 are accepted. Defaults to 100.
    ///     - timeout: Timeout in seconds for long polling. Defaults to 0, i.e. usual short polling. Should be positive, short polling should be used for testing purposes only.
    ///     - allowed_updates: List the types of updates you want your bot to receive. For example, specify [“message”, “edited_channel_post”, “callback_query”] to only receive updates of these types. See Update for a complete list of available update types. Specify an empty list to receive all updates regardless of type (default). If not specified, the previous setting will be used.
    ///       Please note that this parameter doesn't affect updates created before the call to the getUpdates, so unwanted updates may be received for a short period of time.
    /// - Returns: [Update] on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getupdates>
    public func getUpdatesAsync(
            offset: Int? = nil,
            limit: Int? = nil,
            timeout: Int? = nil,
            allowedUpdates: [String]? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: GetUpdatesCompletion? = nil) {
        return requestAsync("getUpdates", defaultParameters["getUpdates"], parameters, [
            "offset": offset,
            "limit": limit,
            "timeout": timeout,
            "allowed_updates": allowedUpdates],
            queue: queue, completion: completion)
    }
}

