// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias GetWebhookInfoCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to get current webhook status. Requires no parameters. On success, returns a WebhookInfo object. If the bot is using getUpdates, will return an object with the url field empty.
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getwebhookinfo>
    @discardableResult
    public func getWebhookInfoSync(_ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("getWebhookInfo", defaultParameters["getWebhookInfo"], parameters)
    }

    /// Use this method to get current webhook status. Requires no parameters. On success, returns a WebhookInfo object. If the bot is using getUpdates, will return an object with the url field empty.
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#getwebhookinfo>
    public func getWebhookInfoAsync(_ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: GetWebhookInfoCompletion? = nil) {
        return requestAsync("getWebhookInfo", defaultParameters["getWebhookInfo"], parameters,
            queue: queue, completion: completion)
    }
}

