// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias PinChatMessageCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to pin a message in a supergroup or a channel. The bot must be an administrator in the chat for this to work and must have the ‘can_pin_messages’ admin right in the supergroup or ‘can_edit_messages’ admin right in the channel. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - message_id: Identifier of a message to pin
    ///     - disable_notification: Pass True, if it is not necessary to send a notification to all chat members about the new pinned message. Notifications are always disabled in channels.
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#pinchatmessage>
    @discardableResult
    public func pinChatMessageSync(
            chatId: ChatId,
            messageId: Int,
            disableNotification: Bool? = nil,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("pinChatMessage", defaultParameters["pinChatMessage"], parameters, [
            "chat_id": chatId,
            "message_id": messageId,
            "disable_notification": disableNotification])
    }

    /// Use this method to pin a message in a supergroup or a channel. The bot must be an administrator in the chat for this to work and must have the ‘can_pin_messages’ admin right in the supergroup or ‘can_edit_messages’ admin right in the channel. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - message_id: Identifier of a message to pin
    ///     - disable_notification: Pass True, if it is not necessary to send a notification to all chat members about the new pinned message. Notifications are always disabled in channels.
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#pinchatmessage>
    public func pinChatMessageAsync(
            chatId: ChatId,
            messageId: Int,
            disableNotification: Bool? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: PinChatMessageCompletion? = nil) {
        return requestAsync("pinChatMessage", defaultParameters["pinChatMessage"], parameters, [
            "chat_id": chatId,
            "message_id": messageId,
            "disable_notification": disableNotification],
            queue: queue, completion: completion)
    }
}

