// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias SendMediaGroupCompletion = (_ result: [Message]?, _ error: DataTaskError?) -> ()

    /// Use this method to send a group of photos or videos as an album. On success, an array of the sent Messages is returned.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - media: A JSON-serialized array describing photos and videos to be sent, must include 2–10 items
    ///     - disable_notification: Sends the messages silently. Users will receive a notification with no sound.
    ///     - reply_to_message_id: If the messages are a reply, ID of the original message
    /// - Returns: [Message] on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#sendmediagroup>
    @discardableResult
    public func sendMediaGroupSync(
            chatId: ChatId,
            media: [InputMedia],
            disableNotification: Bool? = nil,
            replyToMessageId: Int? = nil,
            _ parameters: [String: Any?] = [:]) -> [Message]? {
        return requestSync("sendMediaGroup", defaultParameters["sendMediaGroup"], parameters, [
            "chat_id": chatId,
            "media": media,
            "disable_notification": disableNotification,
            "reply_to_message_id": replyToMessageId])
    }

    /// Use this method to send a group of photos or videos as an album. On success, an array of the sent Messages is returned.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - media: A JSON-serialized array describing photos and videos to be sent, must include 2–10 items
    ///     - disable_notification: Sends the messages silently. Users will receive a notification with no sound.
    ///     - reply_to_message_id: If the messages are a reply, ID of the original message
    /// - Returns: [Message] on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#sendmediagroup>
    public func sendMediaGroupAsync(
            chatId: ChatId,
            media: [InputMedia],
            disableNotification: Bool? = nil,
            replyToMessageId: Int? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: SendMediaGroupCompletion? = nil) {
        return requestAsync("sendMediaGroup", defaultParameters["sendMediaGroup"], parameters, [
            "chat_id": chatId,
            "media": media,
            "disable_notification": disableNotification,
            "reply_to_message_id": replyToMessageId],
            queue: queue, completion: completion)
    }
}

