// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias SetChatDescriptionCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to change the description of a supergroup or a channel. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - description: New chat description, 0-255 characters
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setchatdescription>
    @discardableResult
    public func setChatDescriptionSync(
            chatId: ChatId,
            description: String? = nil,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("setChatDescription", defaultParameters["setChatDescription"], parameters, [
            "chat_id": chatId,
            "description": description])
    }

    /// Use this method to change the description of a supergroup or a channel. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - description: New chat description, 0-255 characters
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setchatdescription>
    public func setChatDescriptionAsync(
            chatId: ChatId,
            description: String? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: SetChatDescriptionCompletion? = nil) {
        return requestAsync("setChatDescription", defaultParameters["setChatDescription"], parameters, [
            "chat_id": chatId,
            "description": description],
            queue: queue, completion: completion)
    }
}

