// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias SetChatPhotoCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to set a new profile photo for the chat. Photos can't be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - photo: New chat photo, uploaded using multipart/form-data
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setchatphoto>
    @discardableResult
    public func setChatPhotoSync(
            chatId: ChatId,
            photo: InputFile,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("setChatPhoto", defaultParameters["setChatPhoto"], parameters, [
            "chat_id": chatId,
            "photo": photo])
    }

    /// Use this method to set a new profile photo for the chat. Photos can't be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - photo: New chat photo, uploaded using multipart/form-data
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setchatphoto>
    public func setChatPhotoAsync(
            chatId: ChatId,
            photo: InputFile,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: SetChatPhotoCompletion? = nil) {
        return requestAsync("setChatPhoto", defaultParameters["setChatPhoto"], parameters, [
            "chat_id": chatId,
            "photo": photo],
            queue: queue, completion: completion)
    }
}

