// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation
import Dispatch

public extension TelegramBot {
    typealias SetGameScoreCompletion = (_ result: Bool?, _ error: DataTaskError?) -> ()

    /// Use this method to set the score of the specified user in a game. On success, if the message was sent by the bot, returns the edited Message, otherwise returns True. Returns an error, if the new score is not greater than the user's current score in the chat and force is False.
    /// - Parameters:
    ///     - user_id: User identifier
    ///     - score: New score, must be non-negative
    ///     - force: Pass True, if the high score is allowed to decrease. This can be useful when fixing mistakes or banning cheaters
    ///     - disable_edit_message: Pass True, if the game message should not be automatically edited to include the current scoreboard
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    /// - Returns: Bool on success. Nil on error, in which case `TelegramBot.lastError` contains the details.
    /// - Note: Blocking version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setgamescore>
    @discardableResult
    public func setGameScoreSync(
            userId: Int64,
            score: Int,
            force: Bool? = nil,
            disableEditMessage: Bool? = nil,
            chatId: Int64? = nil,
            messageId: Int? = nil,
            inlineMessageId: String? = nil,
            _ parameters: [String: Any?] = [:]) -> Bool? {
        return requestSync("setGameScore", defaultParameters["setGameScore"], parameters, [
            "user_id": userId,
            "score": score,
            "force": force,
            "disable_edit_message": disableEditMessage,
            "chat_id": chatId,
            "message_id": messageId,
            "inline_message_id": inlineMessageId])
    }

    /// Use this method to set the score of the specified user in a game. On success, if the message was sent by the bot, returns the edited Message, otherwise returns True. Returns an error, if the new score is not greater than the user's current score in the chat and force is False.
    /// - Parameters:
    ///     - user_id: User identifier
    ///     - score: New score, must be non-negative
    ///     - force: Pass True, if the high score is allowed to decrease. This can be useful when fixing mistakes or banning cheaters
    ///     - disable_edit_message: Pass True, if the game message should not be automatically edited to include the current scoreboard
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    /// - Returns: Bool on success. Nil on error, in which case `error` contains the details.
    /// - Note: Asynchronous version of the method.
    ///
    /// - SeeAlso: <https://core.telegram.org/bots/api#setgamescore>
    public func setGameScoreAsync(
            userId: Int64,
            score: Int,
            force: Bool? = nil,
            disableEditMessage: Bool? = nil,
            chatId: Int64? = nil,
            messageId: Int? = nil,
            inlineMessageId: String? = nil,
            _ parameters: [String: Any?] = [:],
            queue: DispatchQueue = .main,
            completion: SetGameScoreCompletion? = nil) {
        return requestAsync("setGameScore", defaultParameters["setGameScore"], parameters, [
            "user_id": userId,
            "score": score,
            "force": force,
            "disable_edit_message": disableEditMessage,
            "chat_id": chatId,
            "message_id": messageId,
            "inline_message_id": inlineMessageId],
            queue: queue, completion: completion)
    }
}

