// Telegram Bot SDK for Swift (unofficial).
// This file is autogenerated by API/generate_wrappers.rb script.

import Foundation


/// This object contains basic information about an invoice.
///
/// - SeeAlso: <https://core.telegram.org/bots/api#invoice>

public struct Invoice: JsonConvertible, InternalJsonConvertible {
    /// Original JSON for fields not yet added to Swift structures.
    public var json: Any {
        get {
            return internalJson.object
        }
        set {
            internalJson = JSON(newValue)
        }
    }
    internal var internalJson: JSON

    /// Product name
    public var title: String {
        get { return internalJson["title"].stringValue }
        set { internalJson["title"].stringValue = newValue }
    }

    /// Product description
    public var description: String {
        get { return internalJson["description"].stringValue }
        set { internalJson["description"].stringValue = newValue }
    }

    /// Unique bot deep-linking parameter that can be used to generate this invoice
    public var startParameter: String {
        get { return internalJson["start_parameter"].stringValue }
        set { internalJson["start_parameter"].stringValue = newValue }
    }

    /// Three-letter ISO 4217 currency code
    public var currency: String {
        get { return internalJson["currency"].stringValue }
        set { internalJson["currency"].stringValue = newValue }
    }

    /// Total price in the smallest units of the currency (integer, not float/double). For example, for a price of US$ 1.45 pass amount = 145. See the exp parameter in currencies.json, it shows the number of digits past the decimal point for each currency (2 for the majority of currencies).
    public var totalAmount: Int {
        get { return internalJson["total_amount"].intValue }
        set { internalJson["total_amount"].intValue = newValue }
    }

    internal init(internalJson: JSON = [:]) {
        self.internalJson = internalJson
    }
    public init(json: Any) {
        self.internalJson = JSON(json)
    }
    public init(data: Data) {
        self.internalJson = JSON(data: data)
    }
}
